package org.stm.audit.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.stm.audit.entity.AuditInnerCtrlItem;
import org.stm.audit.service.IAuditInnerCtrlItemService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.apache.shiro.authz.annotation.RequiresPermissions;

 /**
 * @Description: 内控要求条目
 * @Author: jeecg-boot
 * @Date:   2025-03-24
 * @Version: V1.0
 */
@Api(tags="内控要求条目")
@RestController
@RequestMapping("/audit/auditInnerCtrlItem")
@Slf4j
public class AuditInnerCtrlItemController extends JeecgController<AuditInnerCtrlItem, IAuditInnerCtrlItemService> {
	@Autowired
	private IAuditInnerCtrlItemService auditInnerCtrlItemService;
	
	/**
	 * 分页列表查询
	 *
	 * @param auditInnerCtrlItem
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "内控要求条目-分页列表查询")
	@ApiOperation(value="内控要求条目-分页列表查询", notes="内控要求条目-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<AuditInnerCtrlItem>> queryPageList(AuditInnerCtrlItem auditInnerCtrlItem,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<AuditInnerCtrlItem> queryWrapper = QueryGenerator.initQueryWrapper(auditInnerCtrlItem, req.getParameterMap());
		Page<AuditInnerCtrlItem> page = new Page<AuditInnerCtrlItem>(pageNo, pageSize);
		IPage<AuditInnerCtrlItem> pageList = auditInnerCtrlItemService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	 @GetMapping(value = "/listAll")
	 public Result<List<AuditInnerCtrlItem>> queryListAll(AuditInnerCtrlItem auditInnerCtrlItem,
															HttpServletRequest req) {
		 QueryWrapper<AuditInnerCtrlItem> queryWrapper = QueryGenerator.initQueryWrapper(auditInnerCtrlItem, req.getParameterMap());
		 List<AuditInnerCtrlItem> pageList = auditInnerCtrlItemService.list(queryWrapper);
		 return Result.OK(pageList);
	 }


	 /**
	 *   添加
	 *
	 * @param auditInnerCtrlItem
	 * @return
	 */
	@AutoLog(value = "内控要求条目-添加")
	@ApiOperation(value="内控要求条目-添加", notes="内控要求条目-添加")
	@RequiresPermissions("audit:audit_inner_ctrl_item:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody AuditInnerCtrlItem auditInnerCtrlItem) {
		auditInnerCtrlItemService.save(auditInnerCtrlItem);
		return Result.OK("添加成功！");
	}
	
	/**
	 *  编辑
	 *
	 * @param auditInnerCtrlItem
	 * @return
	 */
	@AutoLog(value = "内控要求条目-编辑")
	@ApiOperation(value="内控要求条目-编辑", notes="内控要求条目-编辑")
	@RequiresPermissions("audit:audit_inner_ctrl_item:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody AuditInnerCtrlItem auditInnerCtrlItem) {
		auditInnerCtrlItemService.updateById(auditInnerCtrlItem);
		return Result.OK("编辑成功!");
	}
	
	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "内控要求条目-通过id删除")
	@ApiOperation(value="内控要求条目-通过id删除", notes="内控要求条目-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		auditInnerCtrlItemService.removeById(id);
		return Result.OK("删除成功!");
	}
	
	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "内控要求条目-批量删除")
	@ApiOperation(value="内控要求条目-批量删除", notes="内控要求条目-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.auditInnerCtrlItemService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}
	
	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "内控要求条目-通过id查询")
	@ApiOperation(value="内控要求条目-通过id查询", notes="内控要求条目-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<AuditInnerCtrlItem> queryById(@RequestParam(name="id",required=true) String id) {
		AuditInnerCtrlItem auditInnerCtrlItem = auditInnerCtrlItemService.getById(id);
		if(auditInnerCtrlItem==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(auditInnerCtrlItem);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param auditInnerCtrlItem
    */
    @RequiresPermissions("audit:audit_inner_ctrl_item:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, AuditInnerCtrlItem auditInnerCtrlItem) {
        return super.exportXls(request, auditInnerCtrlItem, AuditInnerCtrlItem.class, "内控要求条目");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequiresPermissions("audit:audit_inner_ctrl_item:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, AuditInnerCtrlItem.class);
    }

	 @AutoLog(value = "内控要求条目-添加")
	 @ApiOperation(value="内控要求条目-添加", notes="内控要求条目-添加")
	 @PostMapping(value = "/batchSave")
	 public Result<String> batchSave(@RequestBody List<AuditInnerCtrlItem> auditInnerCtrlItems) {
		 auditInnerCtrlItemService.saveOrUpdateBatch(auditInnerCtrlItems);

		 return Result.OK("添加成功！");
	 }
}
